<template>
    <div v-if="innerValueCurrentCareType">
        <v-card elevation="1" class="admin-content pa-4">
            <v-btn
                color="primary"
                @click="$router.go(-1)"
                class="mb-4"
            >
                <v-icon left>mdi-keyboard-backspace</v-icon>
                    Retour
                </v-btn>
            <div class="text-h4">Détail type de soin</div>
            <v-form
                ref="form"
                v-model="isFormValid"
                @submit.prevent="submitUpdatedForm"
            >
                <div class="text-h6 mt-6">Informations générales</div>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCareType.id"
                            label="Identifiant"
                            disabled
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCareType.label"
                            :rules="[$utils.rules.required]"
                            :counter="94"
                            label="Label"
                            required
                            clearable
                        />
                    </v-col>
                   
                </v-row>
                <v-row>
                    <v-col cols="12" md="12">
                        <v-textarea
                            v-model="innerValueCurrentCareType.description"
                            :rules="[$utils.rules.required]"
                            label="Description"
                            color="teal"
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-btn color="green" type="submit" dark :disabled="!isFormValid">
                    Enregistrer
                </v-btn>
            </v-form>
        </v-card>
        <v-snackbar
            v-model="careTypeDetailSnackbar"
            :timeout="3000"
        >
            {{snackbarMessage}}
            <template v-slot:action="{ attrs }">
                <v-btn
                    color="blue"
                    text
                    v-bind="attrs"
                    @click="careTypeDetailSnackbar = false"
                >
                    Fermer
                </v-btn>
            </template>
        </v-snackbar>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';

export default {
    name: 'CareTypeDetail',
    data: () => ({
        innerValueCurrentCareType: null,
        isFormValid: true,
        careTypeDetailSnackbar: false,
        snackbarMessage: '',
    }),
    methods: {
        ...mapActions(['loadCareType', 'updateCareType']),
        submitUpdatedForm() {
            this.updateCareType(this.innerValueCurrentCareType)
                .then(() => {
                    this.snackbarMessage = 'Les données ont été sauvegardées';
                    this.careTypeDetailSnackbar = true;
                })
                .catch(() => {
                    this.snackbarMessage = this.getCrudError;
                    this.careTypeDetailSnackbar = true;
                });
        }
    },
    computed: {
        ...mapGetters(['getCurrentCareType', 'getCrudError'])
    },
    async mounted() {
        await this.loadCareType(this.$route.params.careTypeId);
        this.innerValueCurrentCareType = this.getCurrentCareType;
    }
}
</script>

